"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var mongoConnector_1 = require("../../../databases/document/mongo/mongoConnector");
var mongoTestEnvironment_1 = require("../../../test-helpers/mongoTestEnvironment");
var prisma_datamodel_1 = require("prisma-datamodel");
var simpleRelational_1 = require("../data/simpleRelational");
var env = new mongoTestEnvironment_1.MongoTestEnvironment();
describe('Mongo Model Introspector', function () {
    beforeAll(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, env.connect()];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); });
    afterAll(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, env.disconnect()];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, env.clear()];
            case 1: return [2 /*return*/, _a.sent()];
        }
    }); }); });
    it('Should infer a model, embedded types and relations correctly.', function () { return __awaiter(_this, void 0, void 0, function () {
        var connector, introspection, sdl, schema;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, env.createCollection('User', simpleRelational_1.users)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, env.createCollection('Item', simpleRelational_1.items)];
                case 2:
                    _a.sent();
                    connector = new mongoConnector_1.MongoConnector(env.getClient());
                    return [4 /*yield*/, connector.introspect(env.schemaName)];
                case 3:
                    introspection = _a.sent();
                    return [4 /*yield*/, introspection.getDatamodel()];
                case 4:
                    sdl = _a.sent();
                    return [4 /*yield*/, introspection.renderToDatamodelString()];
                case 5:
                    schema = _a.sent();
                    simpleRelational_1.assertUserItemModel(sdl.types);
                    expect(schema).toEqual(simpleRelational_1.schemaString);
                    return [2 /*return*/];
            }
        });
    }); }, 60000);
    it('Should infer a relation with random sampling correctly.', function () { return __awaiter(_this, void 0, void 0, function () {
        var items, others, connector, introspection, sdl, schema, itemType, otherType;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    items = __spread(Array(1000).keys()).map(function (x) {
                        return { _id: "item_" + x, other: "other_" + x };
                    });
                    others = __spread(Array(1000).keys()).filter(function (x) { return Math.random() >= 0.5; })
                        .map(function (x) {
                        return { _id: "other_" + x };
                    });
                    return [4 /*yield*/, env.createCollection('Item', items)];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, env.createCollection('Other', others)];
                case 2:
                    _a.sent();
                    connector = new mongoConnector_1.MongoConnector(env.getClient());
                    return [4 /*yield*/, connector.introspect(env.schemaName)];
                case 3:
                    introspection = _a.sent();
                    return [4 /*yield*/, introspection.getDatamodel()];
                case 4:
                    sdl = _a.sent();
                    return [4 /*yield*/, introspection.renderToDatamodelString()];
                case 5:
                    schema = _a.sent();
                    itemType = prisma_datamodel_1.SdlExpect.type(sdl.types, 'Item', false, false);
                    otherType = prisma_datamodel_1.SdlExpect.type(sdl.types, 'Other', false, false);
                    prisma_datamodel_1.SdlExpect.field(itemType, 'other', false, false, otherType);
                    return [2 /*return*/];
            }
        });
    }); }, 60000);
});
//# sourceMappingURL=relations.js.map