"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var prisma_datamodel_1 = require("prisma-datamodel");
var modelNameAndDirectiveNormalizer_1 = require("./modelNameAndDirectiveNormalizer");
var IntrospectionResult = /** @class */ (function () {
    function IntrospectionResult(databaseType, renderer) {
        this.renderer = renderer || prisma_datamodel_1.DefaultRenderer.create(databaseType);
        this.databaseType = databaseType;
    }
    IntrospectionResult.prototype.renderToDatamodelString = function () {
        return this.renderer.render(this.getDatamodel());
    };
    IntrospectionResult.prototype.getNormalizedDatamodel = function (baseModel) {
        if (baseModel === void 0) { baseModel = null; }
        var model = this.getDatamodel();
        new modelNameAndDirectiveNormalizer_1.default(baseModel).normalize(model);
        return model;
    };
    IntrospectionResult.prototype.renderToNormalizedDatamodelString = function (baseModel) {
        if (baseModel === void 0) { baseModel = null; }
        return this.renderer.render(this.getNormalizedDatamodel(baseModel));
    };
    return IntrospectionResult;
}());
exports.IntrospectionResult = IntrospectionResult;
//# sourceMappingURL=introspectionResult.js.map