import { RelationalConnector, ITable, ITableRelation } from '../relationalConnector';
import { Client } from 'pg';
import { DatabaseType } from 'prisma-datamodel';
import { RelationalIntrospectionResult } from '../relationalIntrospectionResult';
export declare class PostgresConnector extends RelationalConnector {
    client: Client;
    constructor(client: Client);
    getDatabaseType(): DatabaseType;
    protected createIntrospectionResult(models: ITable[], relations: ITableRelation[]): RelationalIntrospectionResult;
    protected query(query: string, params?: any[]): Promise<any[]>;
    listSchemas(): Promise<string[]>;
    protected queryColumnComment(schemaName: string, tableName: string, columnName: string): Promise<string | null>;
    protected queryIndices(schemaName: string, tableName: string): Promise<{
        tableName: string;
        name: string;
        fields: string[];
        unique: boolean;
        isPrimaryKey: boolean;
    }[]>;
    private parseIndexColumns;
}
