"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var introspectionResult_1 = require("../../common/introspectionResult");
var prisma_datamodel_1 = require("prisma-datamodel");
var RelationalIntrospectionResult = /** @class */ (function (_super) {
    __extends(RelationalIntrospectionResult, _super);
    function RelationalIntrospectionResult(model, relations, databaseType, renderer) {
        var _this = _super.call(this, databaseType, renderer) || this;
        _this.model = model;
        _this.relations = relations;
        return _this;
    }
    RelationalIntrospectionResult.prototype.getDatamodel = function () {
        return this.infer(this.model, this.relations);
    };
    RelationalIntrospectionResult.prototype.resolveRelations = function (types, relations) {
        var e_1, _a;
        try {
            for (var relations_1 = __values(relations), relations_1_1 = relations_1.next(); !relations_1_1.done; relations_1_1 = relations_1.next()) {
                var relation = relations_1_1.value;
                this.resolveRelation(types, relation);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (relations_1_1 && !relations_1_1.done && (_a = relations_1.return)) _a.call(relations_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return types;
    };
    RelationalIntrospectionResult.prototype.getDatabaseName = function (obj) {
        if (obj.databaseName !== null) {
            return obj.databaseName;
        }
        else {
            return obj.name;
        }
    };
    RelationalIntrospectionResult.prototype.resolveRelation = function (types, relation) {
        var e_2, _a, e_3, _b, e_4, _c, e_5, _d;
        try {
            // Correctly sets field types according to given FK constraints.
            for (var types_1 = __values(types), types_1_1 = types_1.next(); !types_1_1.done; types_1_1 = types_1.next()) {
                var typeA = types_1_1.value;
                try {
                    for (var types_2 = __values(types), types_2_1 = types_2.next(); !types_2_1.done; types_2_1 = types_2.next()) {
                        var typeB = types_2_1.value;
                        try {
                            for (var _e = __values(typeA.fields), _f = _e.next(); !_f.done; _f = _e.next()) {
                                var fieldA = _f.value;
                                try {
                                    for (var _g = __values(typeB.fields), _h = _g.next(); !_h.done; _h = _g.next()) {
                                        var fieldB = _h.value;
                                        if (relation.sourceColumn === this.getDatabaseName(fieldA) && relation.sourceTable === this.getDatabaseName(typeA) &&
                                            relation.targetColumn === this.getDatabaseName(fieldB) && relation.targetTable === this.getDatabaseName(typeB)) {
                                            if (!fieldB.isId) {
                                                prisma_datamodel_1.GQLAssert.raise("Relation " + typeA.name + "." + fieldA.name + " -> " + typeB.name + "." + fieldB.name + " does not target the PK column of " + typeB.name);
                                            }
                                            fieldA.type = typeB;
                                            return;
                                        }
                                    }
                                }
                                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                                finally {
                                    try {
                                        if (_h && !_h.done && (_d = _g.return)) _d.call(_g);
                                    }
                                    finally { if (e_5) throw e_5.error; }
                                }
                            }
                        }
                        catch (e_4_1) { e_4 = { error: e_4_1 }; }
                        finally {
                            try {
                                if (_f && !_f.done && (_c = _e.return)) _c.call(_e);
                            }
                            finally { if (e_4) throw e_4.error; }
                        }
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (types_2_1 && !types_2_1.done && (_b = types_2.return)) _b.call(types_2);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (types_1_1 && !types_1_1.done && (_a = types_1.return)) _a.call(types_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        prisma_datamodel_1.GQLAssert.raise("Failed to resolve FK constraint " + relation.sourceTable + "." + relation.sourceColumn + " -> " + relation.targetTable + "." + relation.targetColumn + ".");
    };
    /**
     * Removes all types which are only there for NM relations
     * @param types
     */
    RelationalIntrospectionResult.prototype.hideJoinTypes = function (types) {
        var e_6, _a;
        var nonJoinTypes = [];
        var _loop_1 = function (type) {
            var relationFields = type.fields.filter(function (field) { return typeof field.type !== 'string'; });
            var relationAndIdFields = type.fields.filter(function (field) { return typeof field.type !== 'string' || field.isId; });
            // A join type only as two relation fields. And sometimes a primary key.
            var isJoinType = (relationFields.length === 2 && type.fields.length === 2) || (relationAndIdFields.length === 3 && type.fields.length === 3);
            if (isJoinType) {
                // We drop the join type, but add a n:m relation to 
                // the two related tables.
                var _a = __read(relationFields, 2), relA = _a[0], relB = _a[1];
                // Type checking was done above
                var typeA = relA.type;
                var typeB = relB.type;
                var relatedFieldForA = {
                    name: typeB.name,
                    type: typeB,
                    isList: true,
                    isUnique: false,
                    isId: false,
                    isCreatedAt: false,
                    isUpdatedAt: false,
                    isRequired: true,
                    isReadOnly: false,
                    comments: [],
                    directives: [],
                    defaultValue: null,
                    relatedField: null,
                    databaseName: null,
                    relationName: type.name
                };
                var relatedFieldForB = {
                    name: typeA.name,
                    type: typeA,
                    isList: true,
                    isUnique: false,
                    isId: false,
                    isCreatedAt: false,
                    isUpdatedAt: false,
                    isRequired: true,
                    isReadOnly: false,
                    comments: [],
                    directives: [],
                    defaultValue: null,
                    relatedField: relatedFieldForA,
                    databaseName: null,
                    relationName: type.name
                };
                relatedFieldForA.relatedField = relatedFieldForB;
                typeA.fields.push(relatedFieldForA);
                typeA.fields = typeA.fields.filter(function (x) { return x.type !== type; });
                typeB.fields = typeB.fields.filter(function (x) { return x.type !== type; });
                typeB.fields.push(relatedFieldForB);
            }
            else {
                nonJoinTypes.push(type);
            }
        };
        try {
            for (var types_3 = __values(types), types_3_1 = types_3.next(); !types_3_1.done; types_3_1 = types_3.next()) {
                var type = types_3_1.value;
                _loop_1(type);
            }
        }
        catch (e_6_1) { e_6 = { error: e_6_1 }; }
        finally {
            try {
                if (types_3_1 && !types_3_1.done && (_a = types_3.return)) _a.call(types_3);
            }
            finally { if (e_6) throw e_6.error; }
        }
        return nonJoinTypes;
    };
    /**
     * Hides indices on related fields. These are always autmatically created by
     * prisma and dont need to be shown in the datamodel.
     * @param types
     */
    RelationalIntrospectionResult.prototype.hideIndicesOnRelatedFields = function (types) {
        var e_7, _a;
        try {
            for (var types_4 = __values(types), types_4_1 = types_4.next(); !types_4_1.done; types_4_1 = types_4.next()) {
                var type = types_4_1.value;
                // Keep indices which have not exactly one field, or if they have one field, 
                // the field is a scalar field.
                type.indices = type.indices.filter(function (index) {
                    return index.fields.length !== 1 ||
                        typeof index.fields[0].type === 'string';
                });
            }
        }
        catch (e_7_1) { e_7 = { error: e_7_1 }; }
        finally {
            try {
                if (types_4_1 && !types_4_1.done && (_a = types_4.return)) _a.call(types_4);
            }
            finally { if (e_7) throw e_7.error; }
        }
        return types;
    };
    RelationalIntrospectionResult.prototype.hideReservedTypes = function (types) {
        var _this = this;
        return types.filter(function (x) { return !_this.isTypeReserved(x); });
    };
    RelationalIntrospectionResult.prototype.infer = function (model, relations) {
        // TODO: Enums? 
        var _this = this;
        var types = model.map(function (x) { return _this.inferObjectType(x); });
        types = this.resolveRelations(types, relations);
        types = this.hideJoinTypes(types);
        types = this.hideReservedTypes(types);
        types = this.hideIndicesOnRelatedFields(types);
        return {
            comments: [],
            types: types
        };
    };
    RelationalIntrospectionResult.prototype.inferIndex = function (index, fields) {
        var fieldCandidates = fields.filter(function (field) { return index.fields.filter(function (indexField) { return field.name === indexField; }).length > 0; });
        return {
            fields: fieldCandidates,
            name: index.name,
            unique: index.unique
        };
    };
    RelationalIntrospectionResult.prototype.inferObjectType = function (model) {
        var _this = this;
        var e_8, _a;
        var fields = model.columns.map(function (x) { return _this.inferField(x); });
        var indices = model.indices.map(function (x) { return _this.inferIndex(x, fields); });
        // Resolve primary key
        if (model.primaryKey !== null) {
            var pk_1 = model.primaryKey;
            if (pk_1.fields.length === 1) {
                // Single PK field - prisma can do that
                var _b = __read(fields.filter(function (field) { return field.name === pk_1.fields[0]; }), 1), pkField = _b[0];
                if (!pkField) {
                    prisma_datamodel_1.GQLAssert.raise("Index/Schema missmatch during introspection. Field " + pk_1.fields[0] + " used in index, but does not exist on table " + model.name);
                }
                // Hard rename ID field to match old datamodel standard
                if (pkField.name !== 'id') {
                    pkField.databaseName = pkField.name;
                    pkField.name = 'id';
                }
                pkField.isId = true;
            }
            else {
                try {
                    // Compound PK - that's not supported
                    for (var _c = __values(pk_1.fields), _d = _c.next(); !_d.done; _d = _c.next()) {
                        var pkFieldName = _d.value;
                        var _e = __read(fields.filter(function (field) { return field.name === pk_1.fields[0]; }), 1), pkField = _e[0];
                        if (!pkField) {
                            prisma_datamodel_1.GQLAssert.raise("Index/Schema missmatch during introspection. Field " + pk_1.fields[0] + " used in index, but does not exist on table " + model.name);
                        }
                        pkField.isId = true;
                        pkField.comments.push({
                            text: "Multiple ID fields (compound indices) are not supported",
                            isError: true
                        });
                    }
                }
                catch (e_8_1) { e_8 = { error: e_8_1 }; }
                finally {
                    try {
                        if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                    }
                    finally { if (e_8) throw e_8.error; }
                }
            }
        }
        return {
            name: model.name,
            isEmbedded: false,
            isEnum: false,
            fields: fields,
            indices: indices,
            directives: [],
            comments: [],
            databaseName: null
        };
    };
    RelationalIntrospectionResult.prototype.inferField = function (field) {
        var comments = [];
        if (field.comment !== null) {
            comments.push({
                text: field.comment,
                isError: false
            });
        }
        var type = this.toTypeIdentifyer(field.type);
        if (type === null) {
            comments.push({
                text: "Type " + field.type + " is not supported",
                isError: true
            });
            type = field.type;
        }
        return {
            name: field.name,
            isUnique: field.isUnique,
            isRequired: !field.isNullable,
            defaultValue: field.defaultValue !== null ? this.parseDefaultValue(field.defaultValue, type) : null,
            isList: field.isList,
            type: type,
            isId: false,
            relatedField: null,
            relationName: null,
            isCreatedAt: false,
            isUpdatedAt: false,
            isReadOnly: false,
            comments: comments,
            directives: [],
            databaseName: null
        };
    };
    return RelationalIntrospectionResult;
}(introspectionResult_1.IntrospectionResult));
exports.RelationalIntrospectionResult = RelationalIntrospectionResult;
//# sourceMappingURL=relationalIntrospectionResult.js.map